git-rebase.sh 7.8 KB
Newer Older
1 2 3 4 5
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano.
#

6
USAGE='[--onto <newbase>] <upstream> [<branch>]'
7 8 9 10 11
LONG_USAGE='git-rebase replaces <branch> with a new branch of the
same name.  When the --onto option is provided the new branch starts
out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
It then attempts to create a new commit for each commit from the original
<branch> that does not exist in the <upstream> branch.
12

13 14
It is possible that a merge failure will prevent this process from being
completely automatic.  You will have to resolve any such merge failure
15 16 17 18
and run git rebase --continue.  Another option is to bypass the commit
that caused the merge failure with git rebase --skip.  To restore the
original <branch> and remove the .dotest working files, use the command
git rebase --abort instead.
19

20 21 22
Note that if <branch> is not specified on the command line, the
currently checked out branch is used.  You must be in the top
directory of your project to start (or continue) a rebase.
23

24
Example:       git-rebase master~1 topic
25

26 27 28
        A---B---C topic                   A'\''--B'\''--C'\'' topic
       /                   -->           /
  D---E---F---G master          D---E---F---G master
29
'
30
. git-sh-setup
31

32 33 34 35 36
RESOLVEMSG="
When you have resolved this problem run \"git rebase --continue\".
If you would prefer to skip this patch, instead run \"git rebase --skip\".
To restore the original branch and stop rebasing run \"git rebase --abort\".
"
37 38 39 40 41

MRESOLVEMSG="
When you have resolved this problem run \"git rebase --continue\".
To restore the original branch and stop rebasing run \"git rebase --abort\".
"
42
unset newbase
43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126
strategy=recursive
do_merge=
dotest=$GIT_DIR/.dotest-merge
prec=4

continue_merge () {
	test -n "$prev_head" || die "prev_head must be defined"
	test -d "$dotest" || die "$dotest directory does not exist"

	unmerged=$(git-ls-files -u)
	if test -n "$unmerged"
	then
		echo "You still have unmerged paths in your index"
		echo "did you forget update-index?"
		die "$MRESOLVEMSG"
	fi

	if test -n "`git-diff-index HEAD`"
	then
		git-commit -C "`cat $dotest/current`"
	else
		echo "Previous merge succeeded automatically"
	fi

	prev_head=`git-rev-parse HEAD^0`

	# save the resulting commit so we can read-tree on it later
	echo "$prev_head" > "$dotest/`printf %0${prec}d $msgnum`.result"
	echo "$prev_head" > "$dotest/prev_head"

	# onto the next patch:
	msgnum=$(($msgnum + 1))
	printf "%0${prec}d" "$msgnum" > "$dotest/msgnum"
}

call_merge () {
	cmt="$(cat $dotest/`printf %0${prec}d $1`)"
	echo "$cmt" > "$dotest/current"
	git-merge-$strategy "$cmt^" -- HEAD "$cmt"
	rv=$?
	case "$rv" in
	0)
		git-commit -C "$cmt" || die "commit failed: $MRESOLVEMSG"
		;;
	1)
		test -d "$GIT_DIR/rr-cache" && git-rerere
		die "$MRESOLVEMSG"
		;;
	2)
		echo "Strategy: $rv $strategy failed, try another" 1>&2
		die "$MRESOLVEMSG"
		;;
	*)
		die "Unknown exit code ($rv) from command:" \
			"git-merge-$strategy $cmt^ -- HEAD $cmt"
		;;
	esac
}

finish_rb_merge () {
	set -e

	msgnum=1
	echo "Finalizing rebased commits..."
	git-reset --hard "`cat $dotest/onto`"
	end="`cat $dotest/end`"
	while test "$msgnum" -le "$end"
	do
		msgnum=`printf "%0${prec}d" "$msgnum"`
		printf "%0${prec}d" "$msgnum" > "$dotest/msgnum"

		git-read-tree `cat "$dotest/$msgnum.result"`
		git-checkout-index -q -f -u -a
		git-commit -C "`cat $dotest/$msgnum`"

		echo "Committed $msgnum"
		echo '    '`git-rev-list --pretty=oneline -1 HEAD | \
					sed 's/^[a-f0-9]\+ //'`
		msgnum=$(($msgnum + 1))
	done
	rm -r "$dotest"
	echo "All done."
}

127 128 129
while case "$#" in 0) break ;; esac
do
	case "$1" in
130 131 132 133 134 135 136 137
	--continue)
		diff=$(git-diff-files)
		case "$diff" in
		?*)	echo "You must edit all merge conflicts and then"
			echo "mark them as resolved using git update-index"
			exit 1
			;;
		esac
138 139 140 141 142 143 144 145 146 147 148 149 150 151 152
		if test -d "$dotest"
		then
			prev_head="`cat $dotest/prev_head`"
			end="`cat $dotest/end`"
			msgnum="`cat $dotest/msgnum`"
			onto="`cat $dotest/onto`"
			continue_merge
			while test "$msgnum" -le "$end"
			do
				call_merge "$msgnum"
				continue_merge
			done
			finish_rb_merge
			exit
		fi
153 154 155 156
		git am --resolved --3way --resolvemsg="$RESOLVEMSG"
		exit
		;;
	--skip)
157 158 159 160
		if test -d "$dotest"
		then
			die "--skip is not supported when using --merge"
		fi
161
		git am -3 --skip --resolvemsg="$RESOLVEMSG"
162 163 164
		exit
		;;
	--abort)
165 166 167 168 169 170 171 172 173
		if test -d "$dotest"
		then
			rm -r "$dotest"
		elif test -d .dotest
		then
			rm -r .dotest
		else
			die "No rebase in progress?"
		fi
174 175 176
		git reset --hard ORIG_HEAD
		exit
		;;
177 178 179 180 181
	--onto)
		test 2 -le "$#" || usage
		newbase="$2"
		shift
		;;
182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198
	-M|-m|--m|--me|--mer|--merg|--merge)
		do_merge=t
		;;
	-s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
		--strateg=*|--strategy=*|\
	-s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
		case "$#,$1" in
		*,*=*)
			strategy=`expr "$1" : '-[^=]*=\(.*\)'` ;;
		1,*)
			usage ;;
		*)
			strategy="$2"
			shift ;;
		esac
		do_merge=t
		;;
199 200 201 202 203 204 205 206 207
	-*)
		usage
		;;
	*)
		break
		;;
	esac
	shift
done
208

209
# Make sure we do not have .dotest
210
if test -z "$do_merge"
211
then
212 213 214 215 216
	if mkdir .dotest
	then
		rmdir .dotest
	else
		echo >&2 '
217 218 219 220
It seems that I cannot create a .dotest directory, and I wonder if you
are in the middle of patch application or another rebase.  If that is not
the case, please rm -fr .dotest and run me again.  I am stopping in case
you still have something valuable there.'
221 222 223 224 225 226 227 228
		exit 1
	fi
else
	if test -d "$dotest"
	then
		die "previous dotest directory $dotest still exists." \
			'try git-rebase < --continue | --abort >'
	fi
229 230
fi

231
# The tree must be really really clean.
J
Junio C Hamano 已提交
232
git-update-index --refresh || exit
233
diff=$(git-diff-index --cached --name-status -r HEAD)
L
Lukas Sandström 已提交
234
case "$diff" in
235 236 237 238
?*)	echo "$diff"
	exit 1
	;;
esac
J
Junio C Hamano 已提交
239

240 241 242
# The upstream head must be given.  Make sure it is valid.
upstream_name="$1"
upstream=`git rev-parse --verify "${upstream_name}^0"` ||
J
Jason Riedy 已提交
243
    die "invalid upstream $upstream_name"
L
Lukas Sandström 已提交
244

245 246 247 248 249 250 251 252 253
# If a hook exists, give it a chance to interrupt
if test -x "$GIT_DIR/hooks/pre-rebase"
then
	"$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
		echo >&2 "The pre-rebase hook refused to rebase."
		exit 1
	}
fi

254
# If the branch to rebase is given, first switch to it.
255
case "$#" in
256
2)
257
	branch_name="$2"
258
	git-checkout "$2" || usage
259 260 261
	;;
*)
	branch_name=`git symbolic-ref HEAD` || die "No current branch"
262
	branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
263
	;;
264
esac
265
branch=$(git-rev-parse --verify "${branch_name}^0") || exit
266

267 268 269
# Make sure the branch to rebase onto is valid.
onto_name=${newbase-"$upstream_name"}
onto=$(git-rev-parse --verify "${onto_name}^0") || exit
L
Lukas Sandström 已提交
270

271 272 273 274
# Now we are rebasing commits $upstream..$branch on top of $onto

# Check if we are already based on $onto, but this should be
# done only when upstream and onto are the same.
J
Junio C Hamano 已提交
275
if test "$upstream" = "$onto"
276
then
277 278 279 280 281 282
	mb=$(git-merge-base "$onto" "$branch")
	if test "$mb" = "$onto"
	then
		echo >&2 "Current branch $branch_name is up to date."
		exit 0
	fi
283 284
fi

285 286
# Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
git-reset --hard "$onto"
L
Lukas Sandström 已提交
287

288
# If the $onto is a proper descendant of the tip of the branch, then
L
Lukas Sandström 已提交
289
# we just fast forwarded.
290
if test "$mb" = "$onto"
L
Lukas Sandström 已提交
291
then
292
	echo >&2 "Fast-forwarded $branch to $newbase."
L
Lukas Sandström 已提交
293 294 295
	exit 0
fi

296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329
if test -z "$do_merge"
then
	git-format-patch -k --stdout --full-index "$upstream"..ORIG_HEAD |
	git am --binary -3 -k --resolvemsg="$RESOLVEMSG"
	exit $?
fi

# start doing a rebase with git-merge
# this is rename-aware if the recursive (default) strategy is used

mkdir -p "$dotest"
echo "$onto" > "$dotest/onto"
prev_head=`git-rev-parse HEAD^0`
echo "$prev_head" > "$dotest/prev_head"

msgnum=0
for cmt in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
			| perl -e 'print reverse <>'`
do
	msgnum=$(($msgnum + 1))
	echo "$cmt" > "$dotest/`printf "%0${prec}d" $msgnum`"
done

printf "%0${prec}d" 1 > "$dotest/msgnum"
printf "%0${prec}d" "$msgnum" > "$dotest/end"

end=$msgnum
msgnum=1

while test "$msgnum" -le "$end"
do
	call_merge "$msgnum"
	continue_merge
done
330

331
finish_rb_merge